MeshCollection
Date: 2019-10-22

org.jmol.shape

## Class MeshCollection

- java.lang.Object
- - org.jmol.shape.Shape
  - - org.jmol.shape.MeshCollection

- Direct Known Subclasses:
    CGO, Draw, Isosurface

      public abstract class MeshCollection
      extends Shape

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected javajs.util.BS` | `bsDisplay`
    `short` | `colix`
    `protected int` | `color`
    `protected int[]` | `connections`
    `Mesh` | `currentMesh`
    `protected float` | `displayWithinDistance2`
    `protected javajs.util.Lst<javajs.util.P3>` | `displayWithinPoints`
    `boolean` | `explicitID`
    `protected java.util.Map<java.lang.String,Mesh>` | `htObjects`
    `protected boolean` | `isDisplayWithinNot`
    `boolean` | `isFixed`
    `protected Mesh` | `linkedMesh`
    `int` | `meshCount`
    `Mesh[]` | `meshes`
    `protected int` | `modelIndex`
    `int` | `nUnnamed`
    `protected Mesh` | `pickedMesh`
    `protected int` | `pickedModel`
    `protected javajs.util.T3` | `pickedPt`
    `protected int` | `pickedVertex`
    `static java.lang.String` | `PREVIOUS_MESH_ID`
    `protected java.lang.String` | `previousMeshID`
    `java.lang.String[]` | `title`

    - ### Fields inherited from class org.jmol.shape.Shape

      `bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MeshCollection()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `allocMesh(java.lang.String thisID, Mesh m)`
    `protected void` | `checkExplicit(java.lang.String id)`
    `protected void` | `clean()`
    `private void` | `deleteMesh()`
    `void` | `deleteMeshI(int i)`
    `protected void` | `deleteMeshKey(java.lang.String key)`
    `int` | `getIndexFromName(java.lang.String id)`
    `Mesh` | `getMesh(java.lang.String thisID)`
    `protected javajs.util.Lst<Mesh>` | `getMeshList(java.lang.String key, boolean justOne)` Get matching list of meshes, order reversed
    `protected java.util.Map<java.lang.String,java.lang.Object>` | `getPickedPoint(javajs.util.T3 v, int modelIndex)`
    `protected boolean` | `getPropDataMC(java.lang.String property, java.lang.Object[] data)`
    `protected java.lang.Object` | `getPropMC(java.lang.String property, int index)`
    `private java.lang.Object` | `getVertices(Mesh mesh)`
    `void` | `initShape()`
    `void` | `merge(MeshCollection mc)` called by ParallelProcessor at completion
    `protected void` | `resetObjects()`
    `private Mesh` | `setMesh(java.lang.String thisID)`
    `private void` | `setMeshTokenProperty(Mesh m, int tokProp, boolean bProp, boolean testD)`
    `void` | `setModelVisibilityFlags(javajs.util.BS bsModels)`
    `protected void` | `setPropMC(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bs)`
    `protected void` | `setStatusPicked(int flag, javajs.util.T3 v, java.util.Map<java.lang.String,java.lang.Object> map)`
    `protected void` | `setTokenProperty(int tokProp, boolean bProp, boolean testD)`

    - ### Methods inherited from class org.jmol.shape.Shape

      `appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, findNearestAtomIndex, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getProperty, getPropertyData, getPropShape, getShapeDetail, getShapeState, getSize, getSizeG, getTranslucentLabel, initializeShape, initModelSet, replaceGroup, setAtomClickability, setModelSet, setProperty, setPropS, setShapeSizeRD, setSize, setSizeRD, wasClicked`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### meshCount

          public int meshCount

    - #### meshes

          public Mesh[] meshes

    - #### currentMesh

          public Mesh currentMesh

    - #### isFixed

          public boolean isFixed

    - #### nUnnamed

          public int nUnnamed

    - #### colix

          public short colix

    - #### explicitID

          public boolean explicitID

    - #### previousMeshID

          protected java.lang.String previousMeshID

    - #### linkedMesh

          protected Mesh linkedMesh

    - #### modelIndex

          protected int modelIndex

    - #### displayWithinDistance2

          protected float displayWithinDistance2

    - #### isDisplayWithinNot

          protected boolean isDisplayWithinNot

    - #### displayWithinPoints

          protected javajs.util.Lst<javajs.util.P3> displayWithinPoints

    - #### bsDisplay

          protected javajs.util.BS bsDisplay

    - #### title

          public java.lang.String[] title

    - #### pickedMesh

          protected Mesh pickedMesh

    - #### pickedModel

          protected int pickedModel

    - #### pickedVertex

          protected int pickedVertex

    - #### pickedPt

          protected javajs.util.T3 pickedPt

    - #### connections

          protected int[] connections

    - #### htObjects

          protected java.util.Map<java.lang.String,Mesh> htObjects

    - #### color

          protected int color

    - #### PREVIOUS_MESH_ID

          public static final java.lang.String PREVIOUS_MESH_ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MeshCollection

          public MeshCollection()

  - ### Method Detail

    - #### setMesh

          private Mesh setMesh(java.lang.String thisID)

    - #### allocMesh

          public void allocMesh(java.lang.String thisID,
                                Mesh m)

    - #### merge

          public void merge(MeshCollection mc)

      called by ParallelProcessor at completion
      Parameters:
        `mc` -

    - #### initShape

          public void initShape()

      Specified by:
        `initShape` in class `Shape`

    - #### setPropMC

          protected void setPropMC(java.lang.String propertyName,
                                   java.lang.Object value,
                                   javajs.util.BS bs)

    - #### checkExplicit

          protected void checkExplicit(java.lang.String id)

    - #### setTokenProperty

          protected void setTokenProperty(int tokProp,
                                          boolean bProp,
                                          boolean testD)

    - #### setMeshTokenProperty

          private void setMeshTokenProperty(Mesh m,
                                            int tokProp,
                                            boolean bProp,
                                            boolean testD)

    - #### getPropDataMC

          protected boolean getPropDataMC(java.lang.String property,
                                          java.lang.Object[] data)

    - #### getMeshList

          protected javajs.util.Lst<Mesh> getMeshList(java.lang.String key,
                                                      boolean justOne)

      Get matching list of meshes, order reversed
      Parameters:
        `key` -
        `justOne` -
      Returns:
        list in reverse order, highest index first

    - #### getPropMC

          protected java.lang.Object getPropMC(java.lang.String property,
                                               int index)

    - #### getVertices

          private java.lang.Object getVertices(Mesh mesh)

    - #### clean

          protected void clean()

    - #### deleteMesh

          private void deleteMesh()

    - #### deleteMeshKey

          protected void deleteMeshKey(java.lang.String key)

    - #### deleteMeshI

          public void deleteMeshI(int i)

    - #### resetObjects

          protected void resetObjects()

    - #### getMesh

          public Mesh getMesh(java.lang.String thisID)

    - #### getIndexFromName

          public int getIndexFromName(java.lang.String id)

      Overrides:
        `getIndexFromName` in class `Shape`
      Returns:
        index

    - #### setModelVisibilityFlags

          public void setModelVisibilityFlags(javajs.util.BS bsModels)

      Overrides:
        `setModelVisibilityFlags` in class `Shape`

    - #### setStatusPicked

          protected void setStatusPicked(int flag,
                                         javajs.util.T3 v,
                                         java.util.Map<java.lang.String,java.lang.Object> map)

    - #### getPickedPoint

          protected java.util.Map<java.lang.String,java.lang.Object> getPickedPoint(javajs.util.T3 v,
                                                                                    int modelIndex)